          /****************************************************************
          * File: js_melody.js                                            *
          * Vers.:1.0                                                     *
          * Javascript Library for parsing EsacCode                       *
          *                                                               *
          * (c) 2005 Klaus Frieler, kgf@omniversum.de                     *
          *                                                               *
          ****************************************************************/  				



          /****************************************************************
          * Helper functions 
          ****************************************************************/  				

  				function setResult(sText, nRowLength)
  				{
  					var resultDiv = document.getElementById("result");
  					if(arguments.length<1) return;
  					if(arguments.length<2) nRowLength = 0;
  					if(resultDiv && sText.length){
  						var tmp = substituteCRwithBR(sText);
  						tmp = format(tmp, nRowLength);
  						resultDiv.innerHTML = tmp;
  					}
  				}
  				
  				function substituteCRwithBR(sText)
  				{
  					var sResult = "";
  					for(var i = 0; i<sText.length; ++i){
  						if(sText.charAt(i) == '\n'){
  							sResult += "<br/>"
  						}
  						else sResult += sText.charAt(i);
  					}
  					return sResult;
  				}
          /****************************************************************
          * MIDI Pitch help functions 
          ****************************************************************/  				
          var toneNames = new Array( new Array("C", 0),  new Array("D", 2),new Array("E", 4), new Array("F", 5), new Array("G", 7), new Array("A", 9), new Array("H", 11), new Array("B", 11),   
                                     new Array("1", 0),  new Array("2", 2),new Array("3", 4), new Array("4", 5), new Array("5", 7), new Array("6", 9), new Array("7", 11));   
          function getPitchClass(sToneName)
          {
            var baseTone= sToneName.charAt(0).toUpperCase();
            var pc = -1;
            for(var i = 0; i<toneNames.length; ++i){
              if(toneNames[i][0] == baseTone){
                pc = toneNames[i][1];
                if(sToneName.length>1){
                  if(sToneName.charAt(1) =="#")pc++;
                  if(sToneName.charAt(1) =="b")pc--;
                }
                if(pc<0) pc   += 12;
                if(pc>=12) pc -= 12;
                break;
              }
            }
             return pc;
          }
          /****************************************************************
          * Functions for retrieving song informations from HTML-file
          ****************************************************************/  				
  				
  				var songList = new Array();
  				var songIds  = new Array();
  				
  				function getDataByEsacId(sId, sKey)
  				{
  				  var sData = "";
  					var ids = document.getElementsByTagName("td");
  					for(i = 0; i< ids.length; ++i){
  						var tdID =ids[i].getAttribute("id"); 
  						if(tdID && tdID.length){					
  							var tmp = tdID.split(":");
  							if(tmp[0] == sKey && tmp[1] == sId){ 
  							  sData= ids[i].innerHTML;
  							  break;
  							}
  						}					
  					}
  					return sData;
  				}

  				function readSong(id)
  				{
			      var sTitle =  getDataByEsacId(id, "Title");
			      var sKey   =  getDataByEsacId(id, "Key");
			      var sUnit  =  getDataByEsacId(id, "Unit");
			      var sSig   =  getDataByEsacId(id, "Sig");
			      var sCode  =  getDataByEsacId(id, "Code");
            return new Song(id, sTitle, sKey, sSig, sUnit, sCode);
  				}

  				function readSongs()
  				{
  					var ids = document.getElementsByTagName("td");
  					for(var i = 0; i< ids.length; ++i){
  						var tdID =ids[i].getAttribute("id"); 
  						if(tdID && tdID.length){					
  							var tmp = tdID.split(":");
  							if(tmp[0] == "Code"){ 
  							  var song = readSong(tmp[1]);
      			      songList.push(song);
  								songIds.push(tmp[1]);
  								//alert("Added element #" + songIds.length + " <- " + tmp[1] + " " + song.title);
  							}
  						}					
  					}
  				  return songList.length;  			  
  				}
  				
  				function formatEsacCode()
  				{
  					var ids = document.getElementsByTagName("td");
  					for(var i = 0; i< ids.length; ++i){
  						var tdID =ids[i].getAttribute("id"); 
  						if(tdID && tdID.length){					
  							var tmp = tdID.split(":");
  							if(tmp[0] == "Code"){ 
  							  song = ids[i].innerHTML;
  								ids[i].innerHTML= substituteCRwithBR(song); 
  								//alert("Added element #" + songIds.length + " <- " + tmp[1]);
  							}
  						}					
  					}
  				}

  				function format(sText, nRowLength)
  				{
  				  var sRet = "";
  				  if(arguments.length<2 || !nRowLength) return sText;
  				  var nRowCount  = 0;
  				  for(var i = 0; i< sText.length; ){
  				    var sNote = getNote(i, sText);
  				    var l = sNote.length;  				    
  				    if(l==0) i++;
  				    else i+=l; 
              nRowCount += l;
              sRet += leftTrim(sNote);  
  				    if(nRowCount>nRowLength){
  				      sRet+= "<br/>";
  				      nRowCount = 0;  
  				    }  				    
  				  }  
  				  return sRet;
  				}
  				
  				
  				function getSongIdxByEsacId(sId)
  				{
  				  for(var i = 0; i<songIds.length;++i){
  				    if(songIds[i] == sId) return i;
  				  }
  				  return -1;
  				}
  				
  				function getSong(nIdx)
  				{
  					var ret = new Song();
  					if(nIdx<0 || nIdx>= songIds.length) return ret;
            ret =  songList[nIdx];  					 
            return  ret; 				  
  				}
  				function getSongByEsacId(sId)
  				{
  				  var nIdx = getSongIdxByEsacId(sId);
  				  return getSong(nIdx);
  				}
  				function inputID()
  				{
  				    var sId = window.prompt("Bitte Esac-ID eingeben!");
  				    /*
  				    var sCode = getSongFromEsacId(sId).code;
  				    var parser = new EsacParser();
  				    sMelody = parser.removeRhythm(); 
  						setResult(sMelody, 40);
  						*/
              return getSongByEsacId(sId);
                						
  				}
  				/*******************************************************
  				* init() should be called after loading of HTML file
  				********************************************************/
  				
  				function init()
  				{
  				  var nCount = readSongs();  
  				  setResult("Init done. Read " + nCount + " songs", 0);
  				  formatEsacCode();  				  
            var song = inputID();
            setResult(song.code);
  				}
  				
          /****************************************************************
          *
          * Definition of EsacParser-Object methods
          *
          ****************************************************************/  				

          /****************************************************************
          * Predefined helper arrays for EsacParser
          ****************************************************************/  				
            				
  				var digits       = new Array("0", "1", "2", "3", "4", "5", "6", "7");
          var accidential  = new Array("b", "#");
          var prolongation = new Array(".", "_", "^");
          var octaver      = new Array("+", "-");
          var triole       = new Array("(", ")");
          var whitespace   = new Array(" ", "\n");
          var esacChars    = digits.concat(accidential).concat(prolongation).concat(octaver).concat(triole).concat(whitespace);
    
          /****************************************************************
          * Character Recognition functions for EsacParser
          ****************************************************************/  				

  				function isDigit(sChar)
  				{
  				  for(var i = 0; i< digits.length; ++i){
              if(digits[i] == sChar) return true;  				    
  				  }
  				  return false;
  				}
  				function isOctaver(sChar)
  				{
  				  for(var i = 0; i< octaver.length; ++i){
              if(octaver[i] == sChar) return true;  				    
  				  }
  				  return false;
  				}
  				function isProlongation(sChar)
  				{
  				  for(var i = 0; i< prolongation.length; ++i){
              if(prolongation[i] == sChar) return true;  				    
  				  }
  				  return false;
  				}
  				function isAccidential(sChar)
  				{
  				  for(var i = 0; i< accidential.length; ++i){
              if(accidential[i] == sChar) return true;  				    
  				  }
  				  return false;
  				}
  				function isTriole(sChar)
  				{
  				  for(var i = 0; i< triole.length; ++i){
              if(triole[i] == sChar) return true;  				    
  				  }
  				  return false;
  				}
  				function isEsacChar(sChar)
  				{
  				  for(var i = 0; i< esacChars.length; ++i){
              if(esacChars[i] == sChar) return true;  				    
  				  }
  				  return false;
  				}
  				function isCR(sChar)
  				{
            if("\n" == sChar) return true;  				    
  				  return false;
  				}
  				function isSpace(sChar)
  				{
            if(" " == sChar) return true;  				    
  				  return false;
  				}
  				function isWS(sChar)
  				{
            if("\n" == sChar || " " == sChar) return true;  				    
  				  return false;
  				}
  				function isCaret(sChar)
  				{
            if("^" == sChar) return true;  				    
  				  return false;
  				}
  				
          /****************************************************************
          * Retrieval functions for EsacParser
          ****************************************************************/  				

  				function getNote(idx, sCode)
  				{
  				  if(arguments.length<2) sCode = this.code;
  				  var sRet = new Array();
  				  for(var i = idx; i<sCode.length; ++i){
  				    var c  = sCode.charAt(i);
              if(isDigit(c) || isOctaver(c)) break;
              sRet.push(" ");  				    
  				  }
  				  var nDigitCount = 0;
  				  for(; i<sCode.length; i++){
              var c  = sCode.charAt(i);                  				  
              if(isDigit(c)) nDigitCount++;
              if(nDigitCount == 2 || (nDigitCount>0 && isOctaver(c)) || isWS(c) || c == ")") break;
              sRet.push(c);
  				  }  
  				  return sRet.join("");
  				}
  				function getNotesAsArray(sCode)
  				{
  				  if(arguments.length<1) sCode = this.code;
  				  var aRet = new Array();
  				  for(var i = 0; i<sCode.length;){
  				    var sNote = getNote(i, sCode);
  				    if(sNote.length == 0) break;
  				    i += sNote.length; 
              aRet.push(leftTrim(sNote));              
  				  }  
  				  return aRet;
  				}

  				function getPhrase(nIdx, sCode)
  				{
  				  if(arguments.length<2) sCode = this.code;
            if(nIdx<1) nIdx = 1;
            var nPhraseIdx = 1;
  				  var sRet = new Array();
  				  for(var i = 0; i<sCode.length; i++){
              var c  = sCode.charAt(i);              
              if(nPhraseIdx == nIdx)
                sRet.push(c);
              if(isCR(c)) nPhraseIdx++;
              if(nPhraseIdx > nIdx) break;
  				  }  
  				  return sRet.join("");
  				}

  				function getPhraseCount(sCode)
  				{
  				  if(arguments.length<1) sCode = this.code;
  				  var nCount = 0;
  				  for(var i = 0; i<sCode.length; i++){
              var c  = sCode.charAt(i);              
              if(isCR(c)) nCount++;
  				  }  
  				  return nCount+1;
  				}
  				function getBar(nIdx, sCode)
  				{
  				  if(arguments.length<2) sCode = this.code;
            if(nIdx<1) nIdx = 1;
            var nBarIdx = 1;
  				  var sRet = new Array();
  				  for(var i = 0; i<sCode.length; i++){
              var c  = sCode.charAt(i);              
              if(nBarIdx == nIdx)
                sRet.push(c);
              if(isSpace(c)) nBarIdx++;
              if(nBarIdx > nIdx) break;
  				  }  
  				  return sRet.join("");
  				}
  				function getBarCount(sCode)
  				{
  				  if(arguments.length<1) sCode = this.code;
  				  var nCount = 0;
  				  for(var i = 0; i<sCode.length; i++){
              var c  = sCode.charAt(i);              
              if(isSpace(c)) nCount++;
  				  }  
  				  return nCount+1;
  				}


          /****************************************************************
          * Transformation functions for EsacParser
          ****************************************************************/  				
  				
  				function removeAccidentials(sCode)
  				{
  				  if(arguments.length<1) sCode = this.code;
  				  var sRet = new Array();
  				  for(var i = 0; i<sCode.length; ++i){
  				    if(!isAccidential(sCode.charAt(i))) sRet.push(sCode[i]);
  				  }
  				  return sRet.join("");
  				}
  				
  				function removeOctave(sCode)
  				{
  				  if(arguments.length<1) sCode = this.code;
  				  var sRet = new Array();
  				  for(var i = 0; i<sCode.length; ++i){
  				    if(!isOctaver(sCode.charAt(i))) sRet.push(sCode[i]);
  				  }
  				  return sRet.join("");
  				}
  				function removeRhythm(sCode)
  				{
  				  if(arguments.length<1) sCode = this.code;
  				  var sRet = new Array();
  				  for(var i = 0; i<sCode.length; ++i){
  				    if(!isProlongation(sCode.charAt(i)) && !isWS(sCode.charAt(i))) sRet.push(sCode[i]);
  				  }
  				  return sRet.join("");
  				}
  				
  				function removeInvalidChars(sCode)
  				{
  				  if(arguments.length<1) sCode = this.code;
  				  var sRet = new Array();
  				  for(var i = 0; i<sCode.length; ++i){
  				    if(isEsacChar(sCode.charAt(i))){ 
  				      sRet.push(sCode[i]);
  				    }
  				  }
  				  return sRet.join("");
  				}

  				function removePhrases(sCode)
  				{
  				  if(arguments.length<1) sCode = this.code;
  				  var sRet = new Array();
  				  for(var i = 0; i<sCode.length; ++i){
  				    if(!isCR(sCode.charAt(i))) sRet.push(sCode[i]);
  				  }
  				  return sRet.join("");
  				}

  				function removeBars(sCode)
  				{
  				  if(arguments.length<1) sCode = this.code;
  				  var sRet = new Array();
  				  for(var i = 0; i<sCode.length; ++i){
  				    if(" " != sCode.charAt(i)) sRet.push(sCode[i]);
  				  }
  				  return sRet.join("");
  				}

  				function removePunctuation(sCode)
  				{
  				  if(arguments.length<1) sCode = this.code;
  				  var sRet = new Array();
  				  for(var i = 0; i<sCode.length; ++i){
  				    if(" " != sCode.charAt(i) && !isCR(sCode.charAt(i))) sRet.push(sCode[i]);
  				  }
  				  return sRet.join("");
  				}

          /****************************************************************
          * Formatting functions for EsacParser
          ****************************************************************/  				

  				function leftTrim(sCode)
  				{
  				  if(arguments.length<1) sCode = this.code;
  				  for(var i = 0; i<sCode.length ; ++i){
  				    if(!isWS(sCode.charAt(i))) break;
  				  }
  				  return sCode.substring(i, sCode.length);
  				}

  				function rightTrim(sCode)
  				{
  				  if(arguments.length<1) sCode = this.code;
  				  for(var i = sCode.length-1; i>=0 ; i--){
  				    if(!isWS(sCode.charAt(i)) ) break;
  				  }
  				  return sCode.substring(0, i+1);
  				}

  				function trim(sCode)
  				{
  				  if(arguments.length<1) sCode = this.code;
  				  return leftTrim(rightTrim(sCode));  
  				}

  				function uniqueWhiteSpace(sCode)
  				{
  				  if(arguments.length<1) sCode = this.code;
  				  var sRet = new Array();
  				  var bWhiteSpaceSeq = false;
  				  for(var i = 0; i<sCode.length; ++i){
  				    var c = sCode.charAt(i);
  				    if(!isWS(c)){
  				      bWhiteSpaceSeq = false;  				     
  				    }
  				    if(!bWhiteSpaceSeq){ 
  				      sRet.push(c);
  				      if(isWS(c)){
  				        bWhiteSpaceSeq = true;
  				      }
  				    }
  				  }
  				  return sRet.join("");
  				}

  				function normalizeEsacCode(sCode)
  				{
  				  if(arguments.length<1) sCode = this.code;
  				  var sNorm = trim(sCode);
  				  sNorm = removeInvalidChars(sNorm);  				  
  				  sNorm = uniqueWhiteSpace(sNorm);  				  
  				  return sNorm;
  				}
  				
          /****************************************************************
          * Definition of EsacParser-Object 
          ****************************************************************/  				
  				
  				function EsacParser(sCode)
  				{
  				  this.code = "";
  				  if(arguments.length>0){
  				    if(sCode.length) this.code =  normalizeEsacCode(sCode);
  				  }
  				}
  				
  				EsacParser.prototype.normalize          = normalizeEsacCode;
  				EsacParser.prototype.isDigit            = isDigit;
  				EsacParser.prototype.isOctaver          = isOctaver;
  				EsacParser.prototype.isProlongation     = isProlongation;
  				EsacParser.prototype.isAccidential      = isAccidential;
  				EsacParser.prototype.isTriole           = isTriole;
  				EsacParser.prototype.isCR               = isCR;
  				EsacParser.prototype.isSpace            = isSpace;
  				EsacParser.prototype.isCaret            = isCaret;
  				EsacParser.prototype.isWS               = isWS;
  				EsacParser.prototype.removeAccidentials = removeAccidentials;
  				EsacParser.prototype.removeOctave       = removeOctave;
  				EsacParser.prototype.removeRhythm       = removeRhythm;
  				EsacParser.prototype.removePunctuation  = removePunctuation;
  				EsacParser.prototype.getNote            = getNote;
  				EsacParser.prototype.getNotesAsArray    = getNotesAsArray;
  				EsacParser.prototype.getPhraseCount     = getPhraseCount;
  				EsacParser.prototype.getPhrase          = getPhrase;
  				EsacParser.prototype.getBarCount        = getBarCount;
  				EsacParser.prototype.getBar             = getBar;
  				
  				
          /****************************************************************
          * Definition of Song-Object
          ****************************************************************/  				
  				
  				function Song(sEsacId, sTitle, sKey, sSig, sUnit, sCode)
  				{
  				  this.esacId = "";
  				  this.title  = "";
  				  this.key    = "";
  				  this.sig    = "";
  				  this.unit   = "";
  				  this.code   = "";
  				  this.valid  = false;
  				  if(arguments.length<6) return;
  				  this.esacId = sEsacId;
  				  this.title  = sTitle;
  				  this.key    = sKey;
  				  this.sig    = sSig;
  				  this.unit   = sUnit;
  				  this.code   = sCode;
  				  this.valid  = sCode.length != 0;
  				}
  				function getParser()
  				{
  				  return new EsacParser(this.code);  
  				}
          Song.prototype.getParser = getParser;  				
